export const ErrorId = {
  GENERAL: 'GENERAL',
  INVALID_PARAMETERS: 'INVALID_PARAMETERS',
  UNAUTHORIZED: 'UNAUTHORIZED',
  INTERNAL_SERVER_ERROR: 'INTERNAL_SERVER_ERROR',
  RESOURCE_NOT_FOUND: 'RESOURCE_NOT_FOUND',
  FAILED_CLOUDFLARE_CHALLENGE: 'FAILED_CLOUDFLARE_CHALLENGE',
} as const;

export class RestError extends Error {
  status;
  message;
  invalidFields;
  additionalData;
  constructor(status: number, message: string, additionalData: any, invalidFields?: { param: string; value: string }[]) {
    super(`${message}`);
    this.status = status;
    this.message = message;
    this.invalidFields = invalidFields;
    this.additionalData = additionalData;
  }
}
